import * as async_cache_dedupe from 'async-cache-dedupe';
import { StorageMemoryOptions } from 'async-cache-dedupe';

interface CacheDefineOptions {
    ttl?: number;
    stale?: number;
}

declare function AsyncCacheDedupe(options?: CacheDefineOptions): (target: any, propertyKey: string, descriptor: PropertyDescriptor) => void;

type StorageInputMemory = {
    type: 'memory';
    options?: StorageMemoryOptions;
};
interface CacheOptions {
    ttl?: number;
    stale?: number;
    storage?: StorageInputMemory;
}

interface ModuleOptions {
    cacheOptions?: CacheOptions;
}

declare class AsyncCacheDedupeModule {
    static forRoot(options?: ModuleOptions): {
        module: typeof AsyncCacheDedupeModule;
        providers: ({
            provide: symbol;
            useValue: async_cache_dedupe.Cache;
        } | {
            provide: symbol;
            useValue: ModuleOptions;
        })[];
        exports: {
            provide: symbol;
            useValue: async_cache_dedupe.Cache;
        }[];
        global: boolean;
    };
}

export { AsyncCacheDedupe, AsyncCacheDedupeModule };
