"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  AsyncCacheDedupe: () => AsyncCacheDedupe,
  AsyncCacheDedupeModule: () => AsyncCacheDedupeModule
});
module.exports = __toCommonJS(src_exports);

// src/async-cache-dedupe.decorator.ts
var import_common = require("@nestjs/common");

// src/constants/cache.constant.ts
var CACHE = Symbol("CACHE");

// src/async-cache-dedupe.decorator.ts
function AsyncCacheDedupe(options = {}) {
  const injectCache = (0, import_common.Inject)(CACHE);
  return (target, propertyKey, descriptor) => {
    const originalMethod = descriptor.value;
    injectCache(target, "cache");
    const key = `${target.constructor.name}_${propertyKey}`;
    descriptor.value = function(...args) {
      const cache = this["cache"];
      if (!cache[key]) {
        cache.define(key, options, (args2) => {
          return originalMethod.apply(this, args2);
        });
      }
      return cache[key](args);
    };
  };
}

// src/async-cache-dedupe.module.ts
var import_async_cache_dedupe = require("async-cache-dedupe");

// src/constants/cache-module-options.constant.ts
var CACHE_MODULE_OPTIONS = Symbol("CACHE_MODULE_OPTIONS");

// src/async-cache-dedupe.module.ts
var AsyncCacheDedupeModule = class _AsyncCacheDedupeModule {
  static forRoot(options = {}) {
    const cacheProvider = {
      provide: CACHE,
      useValue: (0, import_async_cache_dedupe.createCache)(options.cacheOptions)
    };
    return {
      module: _AsyncCacheDedupeModule,
      providers: [
        {
          provide: CACHE_MODULE_OPTIONS,
          useValue: options
        },
        cacheProvider
      ],
      exports: [cacheProvider],
      global: true
    };
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AsyncCacheDedupe,
  AsyncCacheDedupeModule
});
